SystemOrganization addCategory: #RemoteDebugger!
SystemOrganization addCategory: #'RemoteDebugger-GUI'!
SystemOrganization addCategory: #'RemoteDebugger-Utilities'!

ByteArray variableByteSubclass: #RDBGIPAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:07'!
fromString: aString
	"return a new IP address from a string
	IPAddress fromString: '10.1.10.115'"
	
	^ self newFrom: ((aString findTokens: $.) collect: [:s | s asInteger])! !

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:03'!
local
	"mp 10/30/2005 15:53"
	"return a new IP address from a string
	IPAddress local"
	
	^ self newFrom: NetNameResolver localHostAddress! !

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:03'!
netID1: anInteger1 netID2: anInteger2 hostID1: anInteger3 hostID2: anInteger4
	"mp 10/6/2005 18:53"
	"Return an instance with the 4 bytes of an IP address
	IPAddress netID1: 10 netID2: 1 hostID1: 10 hostID2: 115"
	
	^ self 
		with: anInteger1
		with: anInteger2
		with: anInteger3
		with: anInteger4! !

!RDBGIPAddress methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:05'!
asString
	^ NetNameResolver stringFromAddress: self! !

!RDBGIPAddress methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:05'!
asSymbol
	^ self asString asSymbol! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID1
	"mp 10/6/2005 19:53"
	
	^ self third! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID1: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 3 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID2
	"mp 10/6/2005 19:53"
	
	^ self fourth! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID2: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 4 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID1
	"mp 10/6/2005 19:53"
	
	^ self first! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID1: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 1 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID2
	"mp 10/6/2005 19:53"
	
	^ self second! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID2: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 2 put: anInteger! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
next
	"mp 10/7/2005 14:57"
	
	self nextHostID2! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextHostID1
	"mp 12/19/2005 16:32"
	| gap |
	self hostID1 >= 255
		ifTrue: [gap := self hostID1 - 255.
			0
				to: gap
				do: [:n | self nextNetID2].
			self hostID1: gap]
		ifFalse: [self hostID1: self hostID1 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextHostID2
	"mp 12/19/2005 16:32"
	| gap |
	self hostID2 >= 255
		ifTrue: [gap := self hostID2 - 255.
			0
				to: gap
				do: [:n | self nextHostID1].
			self hostID2: gap]
		ifFalse: [self hostID2: self hostID2 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextNetID1
	"mp 12/19/2005 16:30"
	self netID1 >= 255
		ifTrue: [UTMaximumIPReached signal]
		ifFalse: [self netID1: self netID1 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextNetID2
	"mp 12/19/2005 16:32"
	| gap |
	self netID2 >= 255
		ifTrue: [gap := self netID2 - 255.
			0
				to: gap
				do: [:n | self nextNetID1].
			self netID2: gap]
		ifFalse: [self netID2: self netID2 + 1]! !

Debugger subclass: #RDBGClientDebugger
	instanceVariableNames: 'debuggerID remoteData codePane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger'!

!RDBGClientDebugger methodsFor: 'private' stamp: 'LionelLi 4/28/2013 19:16'!
buildTextMorph
	codePane := (PluggableTextMorph on: self text: #contents accept: nil readSelection: #contentsSelection menu: #codePaneMenu:shifted:) font: StandardFonts codeFont.
	^codePane! !

!RDBGClientDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 06:04'!
buttonRowForPreDebugWindow: aDebugWindow
	"Answer a row of button for a pre-debug notifier."
	
	| buttons quads |
	buttons := OrderedCollection with: (AlignmentMorph newVariableTransparentSpacer).
	quads := OrderedCollection withAll: self preDebugButtonQuads.
	(self interruptedContextSelector == #doesNotUnderstand:) ifTrue: [
		quads add: { 'Create'. #createMethod. #magenta. 'create the missing method' }].
	quads do: [:quad |
		buttons add: ((PluggableButtonMorph
			on: aDebugWindow
			getState: nil
			action: quad second)
		label: quad first;
		setBalloonText: quad fourth;
		useSquareCorners;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill).
		buttons add: AlignmentMorph newVariableTransparentSpacer].
	^(self theme builder newRow:  buttons)
		cellInset: 2! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/28/2013 19:17'!
codePaneMenu: aMenu shifted: shifted
"	aMenu add: 'run to here' target: self selector: #runToSelection: argument: thisContext sender receiver selectionInterval.
	aMenu addLine.
	super codePaneMenu: aMenu shifted: shifted.
	^aMenu."
	self shouldBeImplemented.! !

!RDBGClientDebugger methodsFor: 'initialization' stamp: 'LionelLi 4/28/2013 18:44'!
contents: aText notifying: aController
	"The retrieved information has changed and its source must now be updated.
	 In this case, the retrieved information is the method of the selected context."
	Transcript show: 'Called RDBGClientDebugger >> contents:notifying:'; cr.
	aController inspect.
	self shouldBeImplemented.
	^true! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/28/2013 00:29'!
contextStackKey: aChar from: view
	"Respond to a keystroke in the context list"
	self shouldBeImplemented.! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/28/2013 00:29'!
contextStackMenu: aMenu shifted: shifted 
	"Set up the menu appropriately for the context-stack-list, either shifted
	or unshifted as per the parameter provided"
	self shouldBeImplemented.! !

!RDBGClientDebugger methodsFor: 'private' stamp: 'LionelLi 4/27/2013 05:49'!
createMethod
	self shouldBeImplemented
! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/28/2013 01:29'!
debug
	"Open a full DebuggerView."
	| msg |
	msg := (RDBGDebugMessage debuggerID: debuggerID).
	msg sendTo: RDBGClient remoteHostProxy.! !

!RDBGClientDebugger methodsFor: 'initialize' stamp: 'LionelLi 4/27/2013 21:47'!
debugAt: anInteger
	| msg |
	Transcript show: 'Debug button pressed at index: ', anInteger asString; cr.
	msg := (RDBGDebugMessage debuggerID: debuggerID) stackIndex: anInteger.
	msg sendTo: RDBGClient remoteHostProxy.
! !

!RDBGClientDebugger methodsFor: 'accessing' stamp: 'LionelLi 4/27/2013 23:45'!
debuggerID
	^ debuggerID! !

!RDBGClientDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 16:52'!
debuggerID: aString contents: aDictionary
	debuggerID := aString.
	"remoteData := aDictionary."
	"contextStackList := remoteData at: #contextStackList."
	self processRemoteData: aDictionary.
	contextStackIndex := 0! !

!RDBGClientDebugger methodsFor: 'context stack menu' stamp: 'LionelLi 4/27/2013 21:30'!
doStep
	"Send the selected message in the accessed method, and regain control 
	after the invoked method returns."
	
	self shouldBeImplemented
! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/27/2013 21:27'!
down
	"move down the context stack to the previous (enclosing) context"
	self shouldBeImplemented! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/28/2013 02:14'!
expandStack
	"A Notifier is being turned into a full debugger.  Show a substantial amount of stack in the context pane."

	"self newStack: (contextStackTop stackOfSize: 20).
	contextStackIndex := 0."
	receiverInspector := Smalltalk tools inspector inspect: nil.
	contextVariablesInspector := ContextVariablesInspector inspect: nil.
	proceedValue := nil
! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/27/2013 21:31'!
fullStack
	"Change from displaying the minimal stack to a full one."

	self shouldBeImplemented! !

!RDBGClientDebugger methodsFor: 'initialization' stamp: 'LionelLi 4/28/2013 16:52'!
initialize
	remoteData := Dictionary new.! !

!RDBGClientDebugger methodsFor: 'remote data' stamp: 'LionelLi 4/28/2013 03:35'!
interruptedContextSelector
	"Answer the suspended context of the interrupted process."
	^remoteData at: #interruptedContextSelector
! !

!RDBGClientDebugger methodsFor: 'accessing' stamp: 'LionelLi 4/28/2013 05:54'!
isInterruptedContextDoesNotUnderstand	
	
	^ self interruptedContextSelector == #doesNotUnderstand:! !

!RDBGClientDebugger methodsFor: 'remote data' stamp: 'LionelLi 4/28/2013 03:35'!
isPostMortem
	^ remoteData at: #isPostMortem! !

!RDBGClientDebugger methodsFor: 'accessing' stamp: 'LionelLi 4/28/2013 18:12'!
pcRange
	"Answer the indices in the source code for the method corresponding to 
	the selected context's program counter value."
	^remoteData at: #pcRange.
! !

!RDBGClientDebugger methodsFor: 'context stack menu' stamp: 'LionelLi 4/27/2013 19:29'!
proceed
	"Proceed execution of the receiver's model, starting after the expression at 
	which an interruption occurred."
	| msg topView |
	[msg := RDBGProceedMessage debuggerID: debuggerID.
	msg sendTo: RDBGClient remoteHostProxy] on: Exception do: [:ex | Transcript show: ex asString].
	RDBGClient instance cleanUpDebugger: debuggerID.
	topView := self topView.
	topView delete.
	! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/28/2013 17:49'!
processRemoteData: aDictionary
	remoteData addAll: aDictionary.
	aDictionary keysDo: [:key |
		|value|
		value := aDictionary at: key.
		key = #contents ifTrue: [self contents: value] ifFalse: [
		[self instVarNamed: (key asString) put: value]
		on: Exception do: [remoteData at: key put: value]]
	]
! !

!RDBGClientDebugger methodsFor: 'accessing' stamp: 'LionelLi 4/28/2013 03:36'!
remoteData
	^ remoteData! !

!RDBGClientDebugger methodsFor: 'context stack menu' stamp: 'LionelLi 4/27/2013 21:28'!
restart
	"Proceed from the initial state of the currently selected context. The 
	argument is a controller on a view of the receiver. That view is closed."
	"Closing now depends on a setting (RestartAlsoProceeds class variable)"

	self shouldBeImplemented
! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/27/2013 21:31'!
runToSelection

	self shouldBeImplemented! !

!RDBGClientDebugger methodsFor: 'accessing' stamp: 'LionelLi 4/28/2013 05:00'!
selectedClass
	"Answer the class in which the currently selected context's method was 
	found."
	^ String.
"	^self selectedContext methodClass"! !

!RDBGClientDebugger methodsFor: 'context stack menu' stamp: 'LionelLi 4/27/2013 21:29'!
send
	"Send the selected message in the accessed method, and take control in 
	the method invoked to allow further step or send."

	self shouldBeImplemented! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/27/2013 21:30'!
stepIntoBlock
	"Send messages until you return to the present method context.
	 Used to step into a block in the method."

	self shouldBeImplemented! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/27/2013 05:49'!
storeLog
	self shouldBeImplemented
 ! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/28/2013 07:00'!
toggleContextStackIndex: anInteger 
	| msg |
	msg :=	(RDBGDebuggerEventMessage debuggerID: debuggerID) event: #toggleContextStackIndex: args: anInteger asArray.
	msg sendTo: RDBGClient remoteHostProxy! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/27/2013 21:27'!
up
	"move up the context stack to the next (enclosed) context"
	self shouldBeImplemented! !

!RDBGClientDebugger methodsFor: 'updating' stamp: 'LionelLi 4/28/2013 18:08'!
updateFields
	(self topView submorphs) do: [:subMorph |
		(subMorph isKindOf: PluggableTextMorph) ifTrue: [subMorph update: #contents].
		(subMorph isKindOf: PluggableListMorph) ifTrue: [subMorph updateList]
	].
	codePane update: #contents.

! !

!RDBGClientDebugger methodsFor: 'notifier menu' stamp: 'LionelLi 4/27/2013 19:14'!
windowIsClosing
	"My window is being closed; clean up. Restart the low space watcher."
	Transcript show: 'Window is closing'; cr.
	RDBGClient instance cleanUpDebugger: debuggerID.
	(RDBGCloseWindowMessage debuggerID: debuggerID) sendTo: RDBGClient remoteHostProxy.
	"Send message to problem machine and tell it to release itself"! !

Debugger subclass: #RDBGModelDebugger
	instanceVariableNames: 'debuggerID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger'!

!RDBGModelDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 20:25'!
buildMorphicNotifierLabelled: label message: messageString

	RDBGProxy instance debugRemotely: self labelled: label
! !

!RDBGModelDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 04:34'!
contextStack
	^contextStack! !

!RDBGModelDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 04:35'!
contextStackTop
	^contextStackTop! !

!RDBGModelDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 01:42'!
debug
	| msg |
	"Open a full DebuggerView."
	self breakDependents.
	[msg := (RDBGOpenDebuggerMessage debuggerID: debuggerID) constructFrom: self.
	msg sendTo: RDBGProxy remoteHostProxy] on: Exception do: [:ex | ex inspect].

! !

!RDBGModelDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 01:14'!
debuggerID
	^debuggerID! !

!RDBGModelDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 01:14'!
debuggerID: aString
	debuggerID := aString! !

!RDBGModelDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 20:37'!
resumeProcess: aTopView 
	savedCursor notNil ifTrue:[ savedCursor show].
	interruptedProcess isTerminated
		ifFalse: [errorWasInUIProcess
				ifTrue: [UIManager default resumeUIProcess: interruptedProcess]
				ifFalse: [interruptedProcess resume]].
	"if old process was terminated, just terminate current one"
	interruptedProcess := nil.
	"Before delete, so release doesn't terminate it"
"	aTopView delete.
	World displayWorld."
	Smalltalk installLowSpaceWatcher.
	"restart low space handler"
	errorWasInUIProcess == false
		ifFalse: [Processor terminateActive]! !

!RDBGModelDebugger methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 18:45'!
toggleContextStackIndex: anInteger 
	super toggleContextStackIndex: anInteger.! !

Object subclass: #RDBGClientGUI
	instanceVariableNames: 'mainWindow ctlAddress ctlPort ctlStatus client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-GUI'!

RDBGClientGUI class
	instanceVariableNames: 'instance'!

RDBGClientGUI class
	instanceVariableNames: 'instance'!

!RDBGClientGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:41'!
instance
	instance ifNil: [instance := self new].
	^instance! !

!RDBGClientGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:40'!
open
	self instance open.! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:22'!
client
	^ RDBGClient instance! !

!RDBGClientGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 18:40'!
connectButtonEnabled
	^true
! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:40'!
onCloseButtonClick
	RDBGClient shutDown.
	self updateConnectionStatus: self client getStatusAsString.
	"Add code to disconnect RSTBroker and clean up"
	mainWindow delete.
	Transcript show: 'Close button clicked'; cr.
! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 23:45'!
onConnectButtonClick
	|success|
	"TODO: Do some field validation and prompt user if there is error"
	self client start.
	success := self client connectToRemoteHost.
	success ifFalse: [
		UIManager default inform: 'Connection failed'
	].

	Transcript show: 'Connect button clicked'; cr.
	self updateConnectionStatus: self client getStatusAsString.
! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 20:48'!
open
	|builder content dialog statusString |
	statusString := self client getStatusAsString.
	builder := UITheme builder.
	content := builder newColumn: {
		builder newLabelGroup: {
			'Host address' -> (ctlAddress := ((builder newTextEntryFor: (self client remoteHostID) getText: #ipAddress setText: nil help: 'Host name') minWidth: 200)).
			'Connect to port' -> (ctlPort := builder newTextEntryFor: (self client remoteHostID) getText: #port setText: nil help: 'Port number').
			'Status ' -> (ctlStatus := (builder newLabel: statusString)).
		}.
		(builder newRow: {
			(builder newButtonFor: self action: #onConnectButtonClick getEnabled: #connectButtonEnabled label: 'Connect' help: 'Connect to address').
			(builder newButtonFor: self action: #onCloseButtonClick getEnabled: nil label: 'Close' help: 'Disconnect and close remote debugger').
		} ) listCentering: #bottomRight
	}.

	mainWindow := (content openInWindowLabeled: self title) extent: 400@130.
! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 18:47'!
title
	^'RDBG Client Connection'.! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 19:10'!
updateConnectionStatus: aString
	ctlStatus contents: aString! !

Object subclass: #RDBGHost
	instanceVariableNames: 'isRunning status remoteHostId hostId remoteHostProxy debuggerInstances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger'!

RDBGHost class
	instanceVariableNames: 'instance'!

RDBGHost class
	instanceVariableNames: 'instance'!

RDBGHost subclass: #RDBGClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger'!

!RDBGClient commentStamp: 'LionelLi 4/27/2013 03:36' prior: 0!
RDBGClient has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	hostname	<RDBGClient>
	ipAddress	<ProtoObject>
	servicePort	<RDBGClient>
	isRunning	<Boolean>
	status	<Integer>
	remoteHostId	<RDBGHostID | UTHostID>
	hostId	<ConnectionRefused | HierarchicalURI | HierarchicalUrl | ProtocolClient | RDBGHostID | RSTSocketStreamPool | Socket | URIAuthority | UTHostGUI | UTHostID | UTPresenceDetector | UTPresenceNotifier | ZnClientTests | ZnCredentialTests | ZnDispatcherDelegateTest | ZnEasyTests | ZnFixedClient | ZnHttpClientTests | ZnPortNotANumber | ZnServer | ZnServerTests | ZnStaticFileServerDelegateTests | ZnUrl | ZnUserAgentTests>
	remoteHostProxy	<ProtoObject>
	remoteInstances	<IdentityDictionary> Stores the remote debugger window instance

Class Instance Variables:
	instance	<ApplicationService | RDBGClient | RDBGProxy | UTActiveModel | UTHost | ZnServer>!

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:42'!
defaultHostID
	^RDBGHostID fromString: (RDBGClient defaultHostname, '@', NetNameResolver localAddressString, ':', RDBGClient defaultServicePort asString)
! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:25'!
defaultHostname
	^'$rDBG-Client'! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:25'!
defaultServicePort
	^7777
! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
initialize! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
new
	self error: 'Only one instance of proxy can be created.'! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
reset
	RSTBroker reset.
	^ instance ifNotNil: [instance stop. instance := nil]! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:45'!
show
	RDBGClient reset.
	^ RDBGClientGUI open! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
shutDown
	(instance notNil and: [instance isRunning])
		ifTrue: [instance stop] ! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
startUp
	|inst|
	inst := self instance.
	(instance notNil and: [instance isRunning = false])
		ifTrue: [instance start]! !

!RDBGClient methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 05:32'!
buildNotifyListPane: aDebugger

	^ (PluggableMultiColumnListMorph
		on: aDebugger
		list: #contextStackList
		selected: #contextStackIndex
		changeSelected: #debugAt:
		menu: nil
		keystroke: nil
		wrapSelector: #createColumnsFor:)
		gapSize: 40;
		yourself! !

!RDBGClient methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 23:43'!
buildRemoteNotifierFor: aDebugger labelled: label
	| notifyPane window extentToUse row |
	debuggerInstances at: aDebugger debuggerID put: aDebugger.
	window := (PreDebugWindow labelled: label) model: aDebugger.
	extentToUse := 450 @ 156. "nice and wide to show plenty of the error msg"

	window
		addMorph: (row := aDebugger buttonRowForPreDebugWindow: window)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@row minExtent y)).

	row color: Color transparent.
	notifyPane := self buildNotifyListPane: aDebugger.

	window
		addMorph: notifyPane
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@24 corner: 0@0)).
	window setBalloonTextForCloseBox.
	window openInWorldExtent: extentToUse.
	window currentWorld displayWorld. "helps with interrupt not working somehow."
	^window! !

!RDBGClient methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 15:29'!
cleanUpDebugger: debuggerID
	|debugger|
	debugger := debuggerInstances removeKey: debuggerID ifAbsent: [nil].
	Transcript show: 'Cleaned up debugger ', debuggerID; cr.
! !

!RDBGClient methodsFor: 'testing' stamp: 'LionelLi 4/22/2013 00:58'!
connectTo: aHostID
	|tempProxy success|
	success := false.
	remoteHostProxy ifNotNil: [Transcript show: 'Remote host proxy is already connected'. ^false].
	[tempProxy := (RSTRemoteObjectID fromString: (aHostID asString)) asProxy.
	success := tempProxy registerRemoteClient: (self hostID)]
	on: RSTRemoteObjectUnreachable do: [
		Transcript show: 'Error connecting to remote host ', aHostID asString.
		^false
	].
	
	success ifTrue: [
		remoteHostProxy := tempProxy.
		self status: 1.
	].
	^ success.
! !

!RDBGClient methodsFor: 'testing' stamp: 'LionelLi 4/21/2013 21:27'!
connectToRemoteHost
	^self connectTo: remoteHostId! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/22/2013 03:00'!
handleException: aString
	| objException objLocation |
	objLocation := aString, '@', remoteHostId asStringID.
	Transcript show: objLocation.
	objException := objLocation asLocalObject.
	objException explore.
"	Smalltalk tools debugError: objException."
! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 20:32'!
hostID
	^hostId! !

!RDBGClient methodsFor: 'initialize-release' stamp: 'LionelLi 4/27/2013 15:02'!
initialize
	super initialize.
	remoteHostId := RDBGProxy defaultHostID.
"	hostId := RDBGClient defaultHostID.
	remoteHostId := RDBGProxy defaultHostID.
"! !

!RDBGClient methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
printClientMessage: anObject
	Transcript show: ('RemoteClient: ', anObject); cr.
	anObject inspect
! !

!RDBGHost class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 01:45'!
instance
	^instance ifNil: [instance := super new]! !

!RDBGHost class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 01:45'!
remoteHostProxy
	instance ifNil: [^ nil] ifNotNil: [ ^instance remoteHostProxy ]! !

!RDBGHost class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 15:13'!
reset
	RDBGProxy reset.
	RDBGClient reset.
! !

!RDBGHost methodsFor: 'start/stop' stamp: 'LionelLi 4/28/2013 04:19'!
executeMessage: aByteArray
	| msg |
	Transcript show: 'Executing '.
	[msg := RDBGMessage deserializeAndUnzip: aByteArray asString.
	Transcript show: msg class name, '...'; cr.
	msg execute.] on: Exception do: [:ex | Transcript show: ex; cr]! !

!RDBGHost methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 15:05'!
export
	RSTBroker instance export: self named: self hostID hostname! !

!RDBGHost methodsFor: 'initialize-release' stamp: 'LionelLi 4/27/2013 23:46'!
getDebuggerByID: debuggerID
	| debugger |
	debugger := debuggerInstances at: debuggerID ifAbsent: [nil].
	^ debugger.! !

!RDBGHost methodsFor: 'accessing' stamp: 'LionelLi 4/28/2013 07:36'!
getStatusAsString
	|statusString|
	self status = -1 ifTrue: [ statusString := 'Disconnected' ].
	self status = 0 ifTrue: [ statusString := 'Listening to port ', self hostID port asString ].
	self status = 1 ifTrue: [ statusString := 'Connected to ', remoteHostId asStringID].
	^statusString.! !

!RDBGHost methodsFor: 'start/stop' stamp: 'LionelLi 4/28/2013 07:34'!
initialize
	self status: -1.
	isRunning := false.
	debuggerInstances := Dictionary new.
	hostId := self class defaultHostID.
! !

!RDBGHost methodsFor: 'testing' stamp: 'LionelLi 4/27/2013 10:35'!
isRunning
	^isRunning! !

!RDBGHost methodsFor: 'accessing' stamp: 'LionelLi 4/28/2013 01:47'!
remoteHostID
	^ remoteHostId! !

!RDBGHost methodsFor: 'start/stop' stamp: 'LionelLi 4/28/2013 01:47'!
remoteHostProxy
	^ remoteHostProxy! !

!RDBGHost methodsFor: 'start/stop' stamp: 'LionelLi 4/28/2013 07:34'!
start
	self startRST.
	self export.
	isRunning := true.
	self status: 0.
	Transcript show: 'Starting ', self class asString; cr.
! !

!RDBGHost methodsFor: 'start/stop' stamp: 'LionelLi 4/27/2013 10:43'!
startRST
	RSTBroker startOnPort: (self hostID port) logging: false! !

!RDBGHost methodsFor: 'accessing' stamp: 'LionelLi 4/27/2013 10:43'!
status
	"Get status.
	    -1: Disconnected
	    0: Listening
	    1: Connected"

	^status ifNil: [status := -1]! !

!RDBGHost methodsFor: 'accessing' stamp: 'LionelLi 4/27/2013 10:43'!
status: anInteger
	"Set status.
	    -1: Disconnected
	    0: Listening
	    1: Connected"

	status := anInteger! !

!RDBGHost methodsFor: 'start/stop' stamp: 'LionelLi 4/28/2013 07:43'!
stop
	remoteHostProxy ifNotNil: ["Notify client that proxy is disconnecting"].
	self stopRST.
	isRunning := false.
	self status: -1.
	Transcript show: 'Stopping ', self class asString; cr.
! !

!RDBGHost methodsFor: 'start/stop' stamp: 'LionelLi 4/27/2013 10:44'!
stopRST
	RSTBroker stop
! !

RDBGHost subclass: #RDBGProxy
	instanceVariableNames: 'nextIDSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger'!

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:43'!
defaultHostID
	^RDBGHostID fromString: (RDBGProxy defaultHostname, '@', NetNameResolver localAddressString, ':', RDBGProxy defaultServicePort asString)
! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:24'!
defaultHostname
	^'$rDBG-Proxy'! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:25'!
defaultServicePort
	^6666
! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 17:06'!
instance
	^instance ifNil: [instance := super new]! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 15:29'!
new
	self error: 'Only one instance of proxy can be created.'! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 15:30'!
reset
	RSTBroker reset.
	^ instance ifNotNil: [instance stop. instance := nil]! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:48'!
show
	^ RDBGProxyGUI open! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 07:31'!
shutDown
	(instance notNil and: [instance isRunning]) ifTrue: [
		instance stop
	]! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 16:47'!
startUp
	|inst|
	inst := self instance.
	(instance notNil and: [instance isRunning = false])
		ifTrue: [instance start]! !

!RDBGProxy methodsFor: 'start/stop' stamp: 'LionelLi 4/27/2013 15:28'!
cleanUpDebugger: debuggerID
	|debugger|
	debugger := debuggerInstances removeKey: debuggerID ifAbsent: [nil].
	debugger ifNotNil: [debugger windowIsClosing].
	Transcript show: 'Cleaned up debugger ', debuggerID; cr.
! !

!RDBGProxy methodsFor: 'start/stop' stamp: 'LionelLi 4/28/2013 01:15'!
debugRemotely: aDebugger labelled: label

[	(debuggerInstances size >= self maxDebuggerInstances) ifFalse: [
		| debuggerID msg |
		debuggerID := self getNextRemoteDebuggerID.
		aDebugger debuggerID: debuggerID.
		debuggerInstances at: debuggerID put: aDebugger.
		Transcript show: debuggerInstances; cr.
		msg := RDBGOpenNotifierMessage debuggerID: debuggerID.
		msg label: label; constructFrom: aDebugger.
		msg sendTo: remoteHostProxy.
]] on: Exception do: [:ex | ex inspect ]! !

!RDBGProxy methodsFor: 'initialize-release' stamp: 'LionelLi 4/27/2013 15:38'!
getNextRemoteDebuggerID
	| id |
	id := nextIDSequence.
	nextIDSequence := nextIDSequence + 1.
	^id asString, '@', self hostID asStringID! !

!RDBGProxy methodsFor: 'initialize-release' stamp: 'LionelLi 4/21/2013 21:34'!
hostID
	^hostId ifNil: [hostId := RDBGProxy defaultHostID]! !

!RDBGProxy methodsFor: 'initialize-release' stamp: 'LionelLi 4/27/2013 15:01'!
initialize
	super initialize.
"	hostId := RDBGProxy defaultHostID."
	nextIDSequence := 0
! !

!RDBGProxy methodsFor: 'start/stop' stamp: 'LionelLi 4/27/2013 06:56'!
maxDebuggerInstances
	^ 5! !

!RDBGProxy methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 07:35'!
registerRemoteClient: aHostID
	remoteHostProxy ifNotNil: [^false].
	[remoteHostId := (RDBGHostID new) hostname: aHostID hostname; port: aHostID port; ipAddress: aHostID ipAddress.
	remoteHostProxy := (RSTRemoteObjectID fromString: (remoteHostId asString)) asProxy]
	on: RSTRemoteObjectUnreachable do: [^false].
	self status: 1.
	RDBGProxyGUI instance updateConnectionStatus: self getStatusAsString.
	^true
! !

!RDBGProxy methodsFor: 'initialize-release' stamp: 'LionelLi 4/28/2013 07:52'!
status: anInteger
	|debugger|
	super status: anInteger.

	debugger := Smalltalk tools debugger.
	status = 1
	ifTrue: [
		debugger = RDBGModelDebugger
		ifFalse: [
			Smalltalk tools register: RDBGModelDebugger as: #debugger.
			Transcript show: 'Switched to using RDBGModelDebugger as default debugger'; cr.
		]
	] ifFalse: [
		debugger = RDBGModelDebugger
		ifTrue: [
			Smalltalk tools register: Debugger as: #debugger.
			Transcript show: 'Switched to using Debugger as default debugger'; cr.
		]
	]! !

Object subclass: #RDBGHostID
	instanceVariableNames: 'hostname ipAddress port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGHostID class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:12'!
fromString: aString	
	^ self new fromString: aString! !

!RDBGHostID class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:59'!
hostname: aString ipAddress: anIP port: anInteger
	^ (self new) hostname: aString; ipAddress: anIP; port: anInteger.
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:13'!
= aHostID
	^ (self hostname = aHostID hostname) and:
		[(self ipAddress = aHostID ipAddress) and: 
			[self port = aHostID port]]! !

!RDBGHostID methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:00'!
asString
	^ self hostname, '@', self ipAddress asString, ':', self port asString! !

!RDBGHostID methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:15'!
asStringID
	^ self ipAddress asString , ':' , self port asString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:13'!
fromString: aString 
	| tokens |
	tokens := aString findTokens: '@:'.
	self hostname: tokens first.
	self ipAddress: (RDBGIPAddress fromString: tokens second).
	self port: tokens third asInteger
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:15'!
hash
	^ self hostname hash bitXor: 
		(self ipAddress hash bitXor: self port hash).
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:14'!
hostAtIP
	"return a string in the form 'host@127.0.0.1'"
	
	^ self hostname , '@' , self ipAddress asString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
hostname
	^hostname! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
hostname: aString
	hostname := aString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
ipAddress
	^ipAddress! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:06'!
ipAddress: anIPAddress
	ipAddress := anIPAddress! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:02'!
port
	^port! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:02'!
port: anInteger
	port := anInteger! !

Object subclass: #RDBGMessage
	instanceVariableNames: 'debuggerID contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

RDBGMessage subclass: #RDBGCloseWindowMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGCloseWindowMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 10:03'!
execute
	RDBGProxy instance cleanUpDebugger: debuggerID.
! !

RDBGMessage subclass: #RDBGDebugMessage
	instanceVariableNames: 'stackIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGDebugMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 21:54'!
execute
	| debugger |
	debugger := RDBGProxy instance getDebuggerByID: debuggerID.
	stackIndex ifNil: [debugger debug] ifNotNil: [debugger debugAt: stackIndex].! !

!RDBGDebugMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 21:42'!
stackIndex: anInteger
	stackIndex := anInteger.! !

RDBGMessage subclass: #RDBGDebuggerEventMessage
	instanceVariableNames: 'event args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGDebuggerEventMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 06:11'!
event: aSymbol args: aCollection
	event := aSymbol.
	args := aCollection.! !

!RDBGDebuggerEventMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 15:26'!
execute
	| debugger retMsg |
	event isSymbol ifFalse: [^nil].
	debugger := RDBGProxy instance getDebuggerByID: debuggerID.
	debugger ifNil: [^nil].

	[debugger perform: event withArguments: args] on: MessageNotUnderstood
	do: [:ex | Transcript show: ex; cr; show: 'events: ', event asString; cr; show: 'args: ', args asString. ^nil].

	retMsg := (RDBGDebuggerUpdateMessage debuggerID: debuggerID) constructFrom: debugger.
	retMsg sendTo: RDBGProxy remoteHostProxy
! !

RDBGMessage subclass: #RDBGDebuggerUpdateMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGDebuggerUpdateMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 18:13'!
constructFrom: aDebugger
	contents at: #contents put: aDebugger contents.
	contents at: #contextStackList put: aDebugger contextStackList.
	contents at: #contextStackIndex put: aDebugger contextStackIndex.
	contents at: #pcRange put: aDebugger pcRange.
! !

!RDBGDebuggerUpdateMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 18:29'!
execute
	| debugger |
	debugger := RDBGClient instance getDebuggerByID: debuggerID.
	debugger ifNil: [
		Transcript show: 'Remote debugger not found'
	] ifNotNil: [
		debugger processRemoteData: contents.
		debugger updateFields.
	]! !

!RDBGMessage class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 19:14'!
debuggerID: debuggerID
	^ self new debuggerID: debuggerID! !

!RDBGMessage class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 11:15'!
deserializeAndUnzip: aByteArray
	| ref zipped unzipped buffer msg |
	ref := (ReferenceStream on: ((RWBinaryOrTextStream with: ByteArray new) reset; binary)).
	zipped := GZipReadStream on: aByteArray.
	msg := ReferenceStream unStream: zipped upToEnd.
	^msg! !

!RDBGMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 06:44'!
constructFrom: aDebugger
	self subclassResponsibility! !

!RDBGMessage methodsFor: 'accessing' stamp: 'LionelLi 4/27/2013 05:52'!
contents
	^contents! !

!RDBGMessage methodsFor: 'accessing' stamp: 'LionelLi 4/27/2013 05:53'!
contents: aDictionary
	contents := aDictionary! !

!RDBGMessage methodsFor: 'accessing' stamp: 'LionelLi 4/27/2013 05:52'!
debuggerID
	^debuggerID! !

!RDBGMessage methodsFor: 'accessing' stamp: 'LionelLi 4/27/2013 05:52'!
debuggerID: aString
	debuggerID := aString! !

!RDBGMessage methodsFor: 'execution' stamp: 'LionelLi 4/27/2013 04:40'!
execute
	self subclassResponsibility! !

!RDBGMessage methodsFor: 'initialize-release' stamp: 'LionelLi 4/27/2013 05:51'!
initialize
	contents := IdentityDictionary new.! !

!RDBGMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 01:22'!
sendTo: aRemoteClientObject
	aRemoteClientObject executeMessage: self serializeAndZip.
	Transcript show: self class name, ' successfully sent!!'; cr! !

!RDBGMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 04:43'!
serializeAndZip
	"serialize anObject as a GZipped ByteArray"
	| ref zipped |
	ref := ReferenceStream streamedRepresentationOf: self.
	zipped := GZipWriteStream on: ref.
	zipped nextPutAll: ref.
	zipped close.
	^ zipped encodedStream contents.! !

RDBGMessage subclass: #RDBGOpenDebuggerMessage
	instanceVariableNames: 'contextStack contextStackTop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGOpenDebuggerMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 18:30'!
constructFrom: aDebugger
	| oldContextStackIndex label |
	oldContextStackIndex := aDebugger contextStackIndex.
	aDebugger expandStack. "Sets contextStackIndex to zero"

	contents at: #isPostMortem put: aDebugger isPostMortem.
	contents at: #pcRange put: aDebugger pcRange.
"	contextStack := aDebugger contextStack.
	contextStackTop := aDebugger contextStackTop.
"
	aDebugger toggleContextStackIndex: oldContextStackIndex.
! !

!RDBGOpenDebuggerMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 16:26'!
execute
	| debugger topView |
	debugger := RDBGClient instance getDebuggerByID: debuggerID.
	debugger ifNil: [
		Transcript show: 'Remote debugger not found'
	] ifNotNil: [
		debugger processRemoteData: contents.
		"debugger remoteData addAll: contents."
"		debugger contextStack: contextStack.
		debugger contextStackTop: contextStackTop.
"		topView := debugger topView.
		topView model: nil.
		debugger breakDependents.
		topView delete.
		debugger openFullMorphicLabel: topView label.
	]! !

RDBGMessage subclass: #RDBGOpenNotifierMessage
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGOpenNotifierMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 18:30'!
constructFrom: aDebugger
	aDebugger expandStack.
	label := label, ' [', self debuggerID, ']'.
	contents at: #interruptedContextSelector put: aDebugger interruptedContext selector.
	contents at: #isPostMortem put: aDebugger isPostMortem.
	contents at: #pcRange put: aDebugger pcRange.
	contents at: #contextStackList put: aDebugger contextStackList.
	contents at: #contextStackIndex put: aDebugger contextStackIndex.
! !

!RDBGOpenNotifierMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/28/2013 03:49'!
execute
	| debugger |
	debugger := RDBGClientDebugger new debuggerID: debuggerID  contents: contents.
	debugger errorWasInUIProcess: false.
	RDBGClient instance buildRemoteNotifierFor: debugger labelled: label.! !

!RDBGOpenNotifierMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 06:30'!
label
	^label! !

!RDBGOpenNotifierMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 06:30'!
label: aString
	label := aString! !

RDBGMessage subclass: #RDBGProceedMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGProceedMessage methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/27/2013 16:00'!
execute
	| debugger |
	debugger := RDBGProxy instance getDebuggerByID: debuggerID.
	debugger proceed.
	Transcript show: 'Proceeding with error...'; cr.
! !

Object subclass: #RDBGProxyGUI
	instanceVariableNames: 'hostName portNumber ctlAddress ctlPort ctlStatus mainWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-GUI'!

RDBGProxyGUI class
	instanceVariableNames: 'instance'!

RDBGProxyGUI class
	instanceVariableNames: 'instance'!

!RDBGProxyGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:39'!
instance
	instance ifNil: [instance := self new hostName: 'localhost'].
	^instance! !

!RDBGProxyGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:39'!
open
	self instance open.! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 17:20'!
connectButtonEnabled
	^ true.! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 15:39'!
host
	^ RDBGProxy instance! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:15'!
hostName
	^ NetNameResolver localAddressString! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:04'!
hostName: aString
	hostName := aString! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 21:52'!
initialize
! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 17:30'!
onCloseButtonClick
	RDBGProxy shutDown.
	self updateConnectionStatus: self host getStatusAsString.
	"Add code to disconnect RSTBroker and clean up"
	mainWindow delete.
	Transcript show: 'Close button clicked'; cr.
! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 21:55'!
onConnectButtonClick
	Transcript show: 'Connect button clicked'; cr.
	self updateModelValues.
	RDBGProxy startUp.
	self updateConnectionStatus: self host getStatusAsString.! !

!RDBGProxyGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 22:05'!
open
	|builder content dialog statusString |
	statusString := self host getStatusAsString.
	builder := UITheme builder.
	content := builder newColumn: {
		builder newLabelGroup: {
			'Host address' -> ((builder newTextEntryFor: (self host hostID) getText: #ipAddress setText: #ipAddress: help: 'Host name') disable; minWidth: 200).
			'Listen to port' -> (ctlPort := builder newTextEntryFor: (self host hostID) getText: #port setText: #port: help: 'Port number').
			'Status ' -> (ctlStatus := (builder newLabel: statusString)).
		}.
		(builder newRow: {
			(builder newButtonFor: self action: #onConnectButtonClick getEnabled: #connectButtonEnabled label: 'Connect' help: 'Connect to address').
			(builder newButtonFor: self action: #onCloseButtonClick getEnabled: nil label: 'Close' help: 'Disconnect and close remote debugger').
		} ) listCentering: #bottomRight
	}.

"	dialog := builder newPluggableDialogWindow: 'Proxy Connection Window'  for: content.
	dialog useOKDefaultCancelButton.
	dialog rememberKeyboardFocus: ctlPort.
	builder openModal: dialog.
"
	mainWindow := (content openInWindowLabeled: self title) extent: 400@130; rememberKeyboardFocus: ctlPort.
! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 15:09'!
portNumber
	^portNumber ifNil: [portNumber := '9999']! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:04'!
portNumber: aString
	portNumber := aString asInteger! !

!RDBGProxyGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:42'!
title
	^ 'rDBG Proxy Connection'! !

!RDBGProxyGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 15:07'!
updateConnectionStatus: aString
	ctlStatus contents: aString! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 22:05'!
updateModelValues
	self host hostID port: ctlPort getText asInteger.
! !
RDBGClient initialize!
